;
; Simple sprite demo for NES
; Copyright 2017 Damian Yerrick
;
; Copying and distribution of this file, with or without
; modification, are permitted in any medium without royalty provided
; the copyright notice and this notice are preserved in all source
; code copies.  This file is offered as-is, without any warranty.
;

.include "nes.inc"
.include "global.inc"

OAM = $0200

.segment "ZEROPAGE"
nmis:          .res 1
oam_used:      .res 1  ; starts at 0
cur_keys:      .res 2
new_keys:      .res 2

.segment "CODE"
.proc nmi_handler
  inc nmis
  rti
.endproc

.proc irq_handler
  rti
.endproc

.proc main
  jsr load_main_palette
  jsr draw_bg

forever:

  ; Game logic
  jsr read_pads
  
  lda new_keys
  lsr a
  bcc notRight
    lda #0
    sta nmis
    jsr sinusweep
    jmp testDone
  notRight:
  lsr a
  bcc notLeft
    lda #0
    sta nmis
    jsr pinklfsr
  testDone:
    lda #0
    sta $4015
    sta $4011
  notLeft:
  notPressed:

  lda nmis
vw3:
  cmp nmis
  beq vw3
  
  ; Turn the screen on
  ldx #0
  ldy #0
  lda #VBLANK_NMI|BG_0000|OBJ_1000
  clc
  jsr ppu_screen_on
  jmp forever

.endproc

.proc load_main_palette
  ; seek to the start of palette memory ($3F00-$3F1F)
  ldx #$3F
  stx PPUADDR
  ldx #$00
  stx PPUADDR
copypalloop:
  lda initial_palette,x
  sta PPUDATA
  inx
  cpx #4
  bcc copypalloop
  rts
.endproc

.segment "RODATA"
initial_palette:
  .byt $17,$27,$20,$20

; Include the CHR ROM data
.segment "CHR"
  .res $0400
  .incbin "obj/nes/fizzter16.chr"
  .res $1000
