#!/usr/bin/env python3
from math import cos, pi

tablesize = 256
angfreq = pi * 2 / tablesize
amplitude = 63.5
per_row = 16


def spit_table(values):
    for i in range(0, tablesize, per_row):
        print(".byte "+",".join(str(x) for x in values[i:i + per_row]))

def log2(i):
    if i < 1: return -1
    out = 0
    while i > 0x10:
        i >>= 4
        out += 4
    while i > 1:
        i >>= 1
        out += 1
    return out
    
print(""".export sine4011, ctzindex
.rodata
.align 256
sine4011:""")
spit_table([
    int(round(amplitude * (1 - cos(x * angfreq))))
    for x in range(tablesize)
])
print("ctzindex:")
spit_table([
    max(0, log2(x & (-x)))
    for x in range(tablesize)
])
